<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return null;
    }

    /**
     * 父数据
     *
     * @protected
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected srfparentdata: any = {};

    /**
     * 行为参数
     *
     * @protected
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    protected action:any = '';

    /**
     * 被激活的分页面板
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public activiedTabViewPanel: string = '<#list ctrl.getPSControls() as tabviewpanel><#if tabviewpanel_index==0>${tabviewpanel.name}</#if></#list>';
             
    /**
     * vue 生命周期
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created() {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }

                this.srfparentdata = {};
                this.action = action;
                Object.assign(this.srfparentdata, data);
                this.viewState.next({ tag: this.activiedTabViewPanel, action: action, data: this.srfparentdata });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 分页面板选中
     *
     * @param {*} $event
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public tabPanelClick($event: any) {
        if (!$event) {
            return;
        }
        if (!this.viewState) {
            return;
        }
        this.activiedTabViewPanel = $event;
        this.viewState.next({ tag: this.activiedTabViewPanel, action: this.action, data: this.srfparentdata });
    }

    /**
     * 绘制内容
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
            <tabs animated={false} class='tabexppanel' name='${ctrl.name}' on-on-click={($event: any) => this.tabPanelClick($event)}>
                <#list ctrl.getPSControls() as tabviewpanel>
                <tab-pane index={${tabviewpanel_index}} name='${tabviewpanel.name}' tab='${ctrl.name}' class='<#if tabviewpanel.getPSSysCss?? && tabviewpanel.getPSSysCss()??>${tabviewpanel.getPSSysCss().getCssName()}</#if>'  
                    label={
                        (h: any) => {
                            return (
                                <span class='caption<#if tabviewpanel.getPSSysCss?? && tabviewpanel.getPSSysCss()??> ${tabviewpanel.getPSSysCss().getCssName()}</#if>'>
                                    <#if tabviewpanel.getPSSysImage()??>
                                    <span>
                                    <#assign sysimage = tabviewpanel.getPSSysImage()/>
                                    <#if sysimage.getImagePath() ==  "">
                                        <i class='${sysimage.getCssClass()}'></i>&nbsp;
                                    <#else>
                                        <img src='${sysimage.getImagePath()}'/>&nbsp;
                                    </#if>
                                    </span>
                                    </#if>
                                    ${tabviewpanel.getCaption()}
                                </span>
                            );
                        }
                    }>
                    ${P.getCtrlCode(tabviewpanel, 'CONTROL.html').code}
                </tab-pane>
                </#list>
            </tabs>
        );
    }
}
